import {select,json,csv,geoPath,geoAlbersUsa,geoMercator,scaleOrdinal,schemeCategory10,} from 'd3';
import { feature, mesh } from 'topojson';
const svg = select('svg');

const projection = geoMercator()
  .translate([-600, 590]) // poistion
  .scale([790]); // zoom

const pathGenerator = geoPath().projection(projection);

const colorScale = scaleOrdinal(schemeCategory10);

json('https://gist.githubusercontent.com/Mounikadontireddy/511253446ae6cd23efbe9be16f16fb7e/raw/fcbd8137a96dee3a29ea7a30d0106357fff21359/countrymap.json'
).then((data) => {
  //extracting states data
  const countryShapes = feature(
    data,
    data.objects.IND_adm1
  );
  
countryShapes.features.shift()

  svg
    .selectAll('path')
    .data(countryShapes.features)
    .enter()
    .append('path')
    .attr('class', 'states')
    .attr('fill', (d) => colorScale(d.properties.NAME_1))
    .attr('d', (d) => pathGenerator(d))
    .append('title')
    .text((d) => d.properties.NAME_1);

  svg
    .selectAll('text')
    .data(countryShapes.features)
    .enter()
    .append('text')
    .text((d) => d.properties.NAME_1)
    .attr('x', d=>  pathGenerator.centroid(d)[0]   )
    .attr('y',d=>pathGenerator.centroid(d)[1])
    .attr("text-anchor", "middle")
    .attr("font-size", "9px")
 });